/*------------------------------------------------*/
/* Touch sensor test program R0.1a (C)ChaN, 2007  */
/* ATtiny2313 Internal osc 8MHz                   */
/*------------------------------------------------*/

#include <avr/io.h>
#include <inttypes.h>
#include <avr/pgmspace.h>
#include <avr/sleep.h>
#include <avr/interrupt.h>
#include "suart.h"
#include "xitoa.h"
#include "cs.h"

#define SYSCLK	8000000UL


/*------------------------------------------------*/
/* Global variables                               */

char line[16];	/* Console input buffer */



/*------------------------------------------------*/





void get_sens (int *res, int chs)
{
	int ch, loop;

	/* Clear count accumlator */
	for (ch = 0; ch < chs; ch++) res[ch] = 0;

	/* Capture and accumlate integration time for 1/60 second */
	OCR0A = 8000000UL / 1024 / 60;
	TCNT0 = 0;
	TIFR = _BV(OCF0A);
	TCCR0B = 0b101;
	loop = 0;
	do {
		for (ch = 0; ch < chs; ch++) res[ch] += touch(ch);
		loop++;
	} while ((TIFR & _BV(OCF0A)) == 0);
	TCCR0B = 0;

	/* Mean calculation */
	for (ch = 0; ch < chs; ch++) res[ch] /= loop;
}



/*------------------------------------------------*/
/* Online Monitor                                 */

int main (void)
{
	int n, c, ref[8], val[8];

	PORTB = (1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB3) | (1 << PB4) | (1 << PB6) | (1 << PB7);
	//Ausgang fr Transi
	DDRB  = (1 << DDB5); 

	PORTD = (1 << PD0) | (1 << PD1) | (1 << PD2) | (1 << PD3) | (1 << PD4) | (1 << PD5) | (1 << PD6);
	DDRD =  0b0000000;




	get_sens(ref, 8);	/* Get reference count for each channel */

	/* Standalone mode */
		for (;;) {
			get_sens(val, 8);
			for (c = 0; c < 8; c++) {
				n = val[c] - ref[c];
				if (n < 3) PORTB &= ~(1<<PB5);
				if (n > 5) PORTB |= (1<<PB5);
			}
		}
	

}


